unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Buttons, Dialogs, StdCtrls,
  ExtCtrls, ComCtrls, LCLType, MMSystem;

type

  { TFormAppli }

  TFormAppli = class(TForm)
    ImgList1: TImageList;
    ImgDes123: TImage;
    InfoCoche: TLabel;
    BtnLancer: TButton;
    BtnRejouer: TButton;
    BtnQuitter: TButton;
    CaseCoche1: TCheckBox;
    CaseCoche2: TCheckBox;
    CaseCoche3: TCheckBox;
    ImgDe1: TImage;
    ImgDe2: TImage;
    ImgDe3: TImage;
    Nbredessais: TLabel;
    procedure Tentative(essais: word);
    procedure Rejouer(Sender: TObject);
    procedure BtnLancerClick(Sender: TObject);
    procedure BtnRejouerClick(Sender: TObject);
    procedure BtnQuitterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);

  private
    essais : word;
    a, b, c, reply, boxstyle : integer;
    gagne, x, y, z : string;
    function Combitest(r: string): boolean;

  public

  end;

var
  FormAppli: TFormAppli;

implementation

{$R *.lfm}

{ TFormAppli }

function Tformappli.Combitest(r: string): boolean; //Test des combinaisons gagnantes
begin
  r:= x+y+z;
  result:= false;
    case r of
      '013','031','103','130','301','310': result:= True;
    end;
end;

procedure TFormAppli.Tentative(essais: word); //Comptage des lancers de dés
begin
    case essais of
      0 : Nbredessais.Caption:= 'Premier essai'; //Info 1er essai
      1 : Nbredessais.Caption:= 'Deuxième essai'; //Info 2ème essai
      2 : Nbredessais.Caption:= 'Dernier essai'; //Info dernier essai
      3 : Nbredessais.Caption:= 'Terminé !'; //Info terminé
    end;
end;

procedure TFormAppli.Rejouer(Sender: TObject); //Procédure pour rejouer
begin
  //Afficher les dés au départ
  ImgDes123.Picture.LoadFromFile('dés123.jpg');
  //Montrer le bouton Lancer les dés
  BtnLancer.Show;
  //Remettre le compteur et l'affichage d'essais à zéro
  essais:=0;
  Nbredessais.Caption:= 'Premier essai';
  gagne:=''; //Réinitialisation combinaison
  //Effacer les dés
  ImgDe1.Picture.Clear;
  ImgDe2.Picture.Clear;
  ImgDe3.Picture.Clear;
  //Décocher les cases à cocher
  CaseCoche1.Checked:= False;
  CaseCoche2.Checked:= False;
  CaseCoche3.Checked:= False;
  //Cacher les cases à cocher
  CaseCoche1.Hide;
  CaseCoche2.Hide;
  CaseCoche3.Hide;
  //Cacher l'info des cases à cocher
  InfoCoche.Hide;
  //Cacher le bouton Rejouer
  BtnRejouer.Hide;
  //Montrer le bouton Lancer les dés
  BtnLancer.Show;
end;

procedure TFormAppli.BtnLancerClick(Sender: TObject); //Pour lancer les dés
begin
  inc(essais);
  //Cacher les dés de départ
  ImgDes123.Picture.Clear;
  //Afficher les cases à cocher
  CaseCoche1.Show;
  CaseCoche2.Show;
  CaseCoche3.Show;
  //Afficher l'info de cocher les dés pour les garder
  InfoCoche.Show;
  //Compter le nbre d'essais et l'afficher
  Tentative(essais);
  if Nbredessais.Caption = 'Terminé !' then
    begin
      //Cacher le bouton Lancer les dés après 3 lancers
      BtnLancer.Hide;
      //Cacher l'info cocher les dés à garder
      InfoCoche.Hide;
      //Cacher les cases à cocher
      CaseCoche1.Hide;
      CaseCoche2.Hide;
      CaseCoche3.Hide;
      //Montrer le bouton Rejouer
      BtnRejouer.Show;
    end;
  //Lancer le dé 1 de manière pseudo aléatoire
  randomize;

    a := Random(6); //Tirage de 0 à 5 pour les faces du dé de 1 à 6
    //Lancer et afficher le dé 1 en fonction du statut de sa case à cocher
    if CaseCoche1.Checked = false then
      begin
        x:= FloatToStr(a);
        ImgList1.GetBitmap(a,ImgDe1.Picture.Bitmap);
      end;
    //Fonctionnement identique adapté au dé 2
    b := Random(6);
    if CaseCoche2.Checked = false then
      begin
        y:= FloatToStr(b);
        ImgList1.GetBitmap(b,ImgDe2.Picture.Bitmap);
      end;
    //Fonctionnement identique adapté au dé 3
    c := Random(6);
    if CaseCoche3.Checked = false then
      begin
        z:= FloatToStr(c);
        ImgList1.GetBitmap(c,ImgDe3.Picture.Bitmap);
      end;

    //Comparer la combinaison de dés affichés avec les combinaisons gagnantes
    if Combitest(gagne) = True then //Afficher le message quand c'est gagné
      with application do
      begin
        //Cacher le bouton Lancer
        BtnLancer.Hide;
        BtnRejouer.Hide;
        //Cacher l'info cocher les dés à garder
        InfoCoche.Hide;
        //Cacher les cases à cocher
        CaseCoche1.Hide;
        CaseCoche2.Hide;
        CaseCoche3.Hide;
        PlaySound('Songain.wav',0,SND_ASYNC);
        boxstyle := MB_YESNO;
          reply := MessageBox ('Bravo ! Vous avez gagné. Voulez-vous rejouer ?', 'GAGNE !!!', boxstyle);
        if reply = IDYES then
          Rejouer(Self)
        else
          Close; //Fermer l'application
      end;
end;

procedure TFormAppli.BtnRejouerClick(Sender: TObject); //Rejouer
begin
  Rejouer(Self);
end;

procedure TFormAppli.BtnQuitterClick(Sender: TObject); //Fermer l'application
begin
  Close;
end;

procedure TFormAppli.FormCreate(Sender: TObject);
begin
  //Afficher les dés au départ
  ImgDes123.Picture.LoadFromFile('dés123.jpg');
  //Initialiser les essais
  Nbredessais.Caption:= 'Premier essai';
end;

procedure TFormAppli.FormClose(Sender: TObject; var CloseAction: TCloseAction); //Fermeture application
begin
  Application.Terminate;
end;
end.
